const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ad_events = sequelize.define(
    'ad_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

event_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"impression",


"click"

        ],

      },

event_at: {
        type: DataTypes.DATE,
      
      

      },

session_token: {
        type: DataTypes.TEXT,
      
      

      },

ip_address: {
        type: DataTypes.TEXT,
      
      

      },

user_agent: {
        type: DataTypes.TEXT,
      
      

      },

referrer_url: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ad_events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










































//end loop



    db.ad_events.belongsTo(db.ads, {
      as: 'ad',
      foreignKey: {
        name: 'adId',
      },
      constraints: false,
    });




    db.ad_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ad_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ad_events;
};


